"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var blueprint_1 = require("./blueprint");
var pick_1 = require("./utils/pick");
var shallowEqual_1 = require("./utils/shallowEqual");
function withPropsOnChange(shouldMapOrKeys, propsMapper) {
    var shouldMap = typeof shouldMapOrKeys === "function"
        ? shouldMapOrKeys
        : function (props, nextProps) { return !shallowEqual_1.default(pick_1.default.apply(void 0, [props].concat(shouldMapOrKeys)), pick_1.default.apply(void 0, [nextProps].concat(shouldMapOrKeys))); };
    return {
        instanceCallbacks: function () {
            var previousProps;
            var computedProps;
            return [
                blueprint_1.propsCallback(function (props) {
                    if (previousProps === undefined || shouldMap(previousProps, props)) {
                        computedProps = propsMapper(props);
                    }
                    previousProps = props;
                    return __assign({}, props, computedProps);
                }),
            ];
        },
    };
}
exports.withPropsOnChange = withPropsOnChange;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = withPropsOnChange;

//# sourceMappingURL=withPropsOnChange.js.map
