"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var blueprint_1 = require("./blueprint");
var resolveValue_1 = require("./utils/resolveValue");
function withState(stateName, updaterName, initialValue) {
    return {
        instanceCallbacks: function () {
            var update;
            var name;
            return [
                blueprint_1.stateCallback(function (initState, props) {
                    var newState = initState(String(stateName), resolveValue_1.default(initialValue, props));
                    update = newState.updater;
                    name = newState.name;
                }),
                blueprint_1.propsCallback(function (props, state) {
                    return (__assign({}, props, (_a = {}, _a[stateName] = state[name], _a[updaterName] = update, _a)));
                    var _a;
                }),
            ];
        },
    };
}
exports.withState = withState;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = withState;

//# sourceMappingURL=withState.js.map
