/* tslint:disable: no-bitwise */
import { lazyLoadCallback, skipCallback } from "./blueprint";
import resolveValue from "./utils/resolveValue";
import toArray from "./utils/toArray";
var resolveCallbacks = function (list) { return list.reduce(function (result, c) {
    result.push.apply(result, resolveValue(c.instanceCallbacks));
    return result;
}, []); };
export function branch(test, left, right) {
    if (right === void 0) { right = []; }
    var leftList = toArray(left);
    var rightList = toArray(right);
    return {
        instanceCallbacks: function () {
            var loaded = { left: false, right: false };
            var isTrue;
            return [
                lazyLoadCallback(function (props) {
                    isTrue = test(props);
                    if (!loaded.left && isTrue) {
                        loaded.left = true;
                        var newCallbacks_1 = resolveCallbacks(leftList);
                        newCallbacks_1.unshift(skipCallback(function () { return isTrue ? 0 : newCallbacks_1.length; }));
                        return newCallbacks_1;
                    }
                    if (!loaded.right && !isTrue) {
                        loaded.right = true;
                        var newCallbacks_2 = resolveCallbacks(rightList);
                        newCallbacks_2.unshift(skipCallback(function () { return isTrue ? newCallbacks_2.length : 0; }));
                        return newCallbacks_2;
                    }
                    return null;
                }),
            ];
        },
    };
}
export default branch;

//# sourceMappingURL=branch.js.map
