/// <reference types="react" />
import { ComponentClass, StatelessComponent } from "react";
export declare type ReactComponent<T> = ComponentClass<T> | StatelessComponent<T>;
export declare type ReactAnyComponent = ReactComponent<any> | string;
export declare type ComponentEnhancer<TInner, TOutter> = (component: ReactComponent<TInner>) => ComponentClass<TOutter>;
export declare type Mapper<TIn, TOut> = (input: TIn) => TOut;
export declare type Predicate<T> = Mapper<T, boolean>;
export declare type PredicateDiff<T> = (current: T, next: T) => boolean;
export declare type Indexable = {
    [key: string]: any;
};
